#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <libdv/dv.h>

#define FS 120000
int main (int ac, char ** av) {
	char bufin[FS];
	dv_decoder_t *dv;
	int16_t *bufout[4];
	int fin, fout[4]; // , frame;
	void * c[2];
	dv = dv_decoder_new(TRUE, FALSE, FALSE);
	dv->quality = DV_QUALITY_BEST;
	if (ac <= 2) {
		fprintf(stderr, "Two arguments required\n");
		return 1;
	}

	// input files
	fin = open(av[1], O_RDONLY);

	// output files
	{
		char * cnt = av[2];
		char * outname;
		int len = 0, i;
		while (av[2][len++]);
 		outname = (char*)malloc(sizeof(char) * ( len + 1));
		for(len=0; av[2][len]; len++) {
			outname[len] = av[2][len];
		}
		outname[len+1]=0;
		for (i=0; i<4; i++) {
			outname[len] = i + '0';
			fout[i] = open(outname, O_WRONLY | O_CREAT | O_TRUNC, 0666);
		}
	}


	bufout[0] = malloc(DV_AUDIO_MAX_SAMPLES * sizeof(int16_t));
	bufout[1] = malloc(DV_AUDIO_MAX_SAMPLES * sizeof(int16_t));
	bufout[2] = malloc(DV_AUDIO_MAX_SAMPLES * sizeof(int16_t));
	bufout[3] = malloc(DV_AUDIO_MAX_SAMPLES * sizeof(int16_t));


	while(1) {
		int readcnt = 0;
		int oldread = 0;
		while (readcnt < FS) {
			readcnt += read(fin, bufin + readcnt, FS - readcnt);
			if (oldread >= readcnt) {
				return 0;
			}
			oldread = readcnt;
		}
		printf ("Read a frame:	");
		if (dv_parse_header(dv, bufin) < 0) {
			fprintf(stderr, "Error parsing frame\n");
			return 1;
		}
		dv_decode_full_audio(dv, bufin, bufout);

		printf ("Channels: %3d  Samples: %6d  Freq: %6d", dv_get_num_channels(dv), dv_get_num_samples(dv), dv_get_frequency(dv));
		{
			int channels, i;
			for (i=0, channels=dv_get_num_channels(dv); i< channels; i++) {
				write(fout[i], bufout[i], dv_get_num_samples(dv) * sizeof(int16_t));
			}
		}
		printf("\n");
	}
	close(fin);
	close(fout[0]);
	close(fout[1]);
	close(fout[2]);
	close(fout[3]);
	return 0;
}
